﻿using System;

namespace TestProject
{
    /// <summary>
    /// 감사 정책 어트리뷰트
    /// </summary>
    public class AuditPolicyAttribute : Attribute
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 감사 필요 여부 - NeedsAudit

        /// <summary>
        /// 감사 필요 여부
        /// </summary>
        public bool NeedsAudit { get; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - AuditPolicyAttribute(needsAudit)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="needsAudit">감사 필요 여부</param>
        public AuditPolicyAttribute(bool needsAudit)
        {
            NeedsAudit = needsAudit;
        }

        #endregion
    }
}