using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Routing;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;
using System;

namespace TestProject
{
    /// <summary>
    /// 
    /// </summary>
    public class Startup
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Configuration

        /// <summary>
        /// 
        /// </summary>
        public IConfiguration Configuration { get; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Startup(configuration)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="configuration"></param>
        public Startup(IConfiguration configuration)
        {
            Configuration = configuration;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ÷ ϱ - ConfigureServices(services)

        /// <summary>
        ///  ÷ ϱ
        /// </summary>
        /// <param name="services"> ÷</param>
        public void ConfigureServices(IServiceCollection services)
        {
            services.AddControllersWithViews();
        }

        #endregion
        #region ϱ - Configure(app, environment)

        /// <summary>
        /// ϱ
        /// </summary>
        /// <param name="app">ø̼ </param>
        /// <param name="environment"> ȣƮ ȯ</param>
        public void Configure(IApplicationBuilder app, IWebHostEnvironment environment)
        {
            if(environment.IsDevelopment())
            {
                app.UseDeveloperExceptionPage();
            }

            // ġ 1 :   .  Ǳ  û  ĥ  ִ.
            app.UseHttpMethodOverride();

            app.UseRouting();

            // ġ 2 :   . ̵ Ÿ ͸  ġų  ִ.
            app.Use
            (
                next => context =>
                {
                    Endpoint endpoint = context.GetEndpoint();

                    if(endpoint?.Metadata.GetMetadata<AuditPolicyAttribute>()?.NeedsAudit == true)
                    {
                        Console.WriteLine($"ACCESS TO SENSITIVE DATA AT : {DateTime.UtcNow}");
                    }

                    return next(context);
                }
            );

            app.UseEndpoints
            (
                endpoints =>
                {         
                    endpoints.MapGet
                    (
                        "/",
                        async context =>
                        {
                            await context.Response.WriteAsync("Hello world!");
                        }
                    );

                    // Ÿ ͸ Ͽ  å Ѵ.
                    endpoints.MapGet
                    (
                        "/sensitive",
                        async context =>
                        {
                            await context.Response.WriteAsync("sensitive data");
                        }
                    )
                    .WithMetadata(new AuditPolicyAttribute(needsAudit : true));
                }
            );
        } 

        #endregion
    }
}